Ext.define('dashboard.widget.Placeholder', {extend:'Ext.Container', alias:'widget.dashboardPlaceholderWidget', mixins:['BpcCommon.mixin.Widget'], statics:{WIDGET_NAME:'DASHBOARD_PLACEHOLDER_WIDGET_NAME', WIDGET_DESCRIPTION:'DASHBOARD_PLACEHOLDER_WIDGET_DESCRIPTION', WIDGET_ICON_CLS:'x-fal fa-plus'}, layout:{type:'vbox', pack:'center', align:'middle'}, config:{widgetConfiguration:{title:'Dashboard Widget'}}, initComponent:function() {
  var me = this;
  me.items = [{xtype:'button', iconCls:BpcCommon.Icons.ADD, handler:'openSelectorWindow', columnIndex:me.columnIndex, bind:{hidden:'{!' + dashboard.assets.ModuleRights.editDashboard + '}'}}, {xtype:'box', html:'\x3ch3\x3e' + BpcCommon.lang.Current.DASHBOARD_WIDGET_ADD_DESCRIPTION + '\x3c/h3\x3e'}];
  this.callParent();
}});
Ext.define('dashboard.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['dashboard.widget.Placeholder'], config:{moduleConfigurationComponents:[], widgets:['dashboard.widget.Placeholder']}});
Ext.define('dashboard.Module', {singleton:true, constructor:function() {
}});
Ext.define('dashboard.assets.ConfigKeys', {singleton:true, appToolbarLeftContent:'appToolbarLeftContent', appToolbarRightContent:'appToolbarRightContent', cfg:'configuration', columns:'numberOfColumns', description:'module_description', moduleHeaderContent:'moduleHeaderContent', moduleIconCls:'module_iconCls', moduleName:'module_name', moduleShowHeader:'module_showHeader', widgetMove:'function_widgetMove', widgetJump:'function_widgetJump', widgetRefresh:'function_widgetRefresh', widgetInfo:'function_widgetInfo', 
toolbarRefresh:'function_toolbarRefresh'});
Ext.define('dashboard.assets.Icons', {singleton:true, autoRefreshIcon:'x-fal fa-sync', DASHBOARD:'x-fal fa-desktop', WIDGET:'x-fal fa-tachometer-alt'});
Ext.define('dashboard.assets.ModuleRights', {singleton:true, editDashboard:'bpcDashboard_editDashboard'});
Ext.define('dashboard.view.DashboardColumn', {extend:'Ext.container.Container', alias:'widget.dbColumn', layout:{type:'vbox', align:'stretch'}, padding:'8 0 0 0', minWidth:300, moduleId:undefined, items:[{xtype:'dbWidgetWrapperPlaceHolder'}], initComponent:function() {
  var me = this;
  me.callParent(arguments);
}, onAdd:function(item, position) {
  var me = this;
  if (item instanceof dashboard.view.Splitter) {
    return;
  }
  if (item.attachedSplitter) {
    me.add(position, item.attachedSplitter);
    return;
  }
  if (!(item instanceof dashboard.view.Splitter) && !item.attachedSplitter && position !== 0) {
    item.attachedSplitter = me.add(position, {xtype:'dashboardSplitter'});
  }
  var placeholder = me.down('dbWidgetWrapperPlaceHolder');
  if (placeholder && me.items.getCount() > 1) {
    me.remove(placeholder);
  }
  me.hideOnlyFirstSplitter();
}, onRemove:function(item) {
  var me = this;
  if (me.destroying || me.destroyed) {
    return;
  }
  if (item.attachedSplitter) {
    item.attachedSplitter.destroy();
    delete item.attachedSplitter;
  }
  if (me.items.getCount() === 0) {
    me.add({xtype:'dbWidgetWrapperPlaceHolder'});
  }
  me.hideOnlyFirstSplitter();
}, moveUp:function(item) {
  var me = this;
  var currentIndex = me.items.indexOf(item);
  if (currentIndex <= 1 || item instanceof dashboard.view.Splitter) {
    return;
  }
  var refItem = me.items.getAt(currentIndex - 2);
  if (refItem.attachedSplitter) {
    me.moveBefore(item, refItem.attachedSplitter);
    me.moveBefore(item.attachedSplitter, item);
  }
  me.hideOnlyFirstSplitter();
}, moveDown:function(item) {
  var me = this;
  var currentIndex = me.items.indexOf(item);
  var refItem = me.items.getAt(currentIndex + 2);
  if (refItem) {
    me.moveAfter(item, refItem);
    me.moveBefore(item.attachedSplitter, item);
  }
  me.hideOnlyFirstSplitter();
}, moveBefore:function(item, beforeItem) {
  var me = this;
  me.callParent([item, beforeItem]);
}, moveAfter:function(item, beforeItem) {
  var me = this;
  me.callParent([item, beforeItem]);
}, hideOnlyFirstSplitter:function() {
  var me = this;
  me.items.each(function(item, index) {
    if (item instanceof dashboard.view.Splitter) {
      item.setVisible(index !== 0);
    }
  });
}});
Ext.define('dashboard.view.Main', {extend:'Ext.panel.Panel', alias:'widget.dbMain', controller:'dashboardMainController', ui:'transparent', scrollable:true, header:false, iconCls:dashboard.assets.Icons.DASHBOARD, layout:'card', activeItem:0, applicationToolbarRight:undefined, numberOfColumns:undefined, moduleId:undefined, settingsForVmAndConfigPanel:[dashboard.assets.ConfigKeys.cfg, dashboard.assets.ConfigKeys.columns, dashboard.assets.ConfigKeys.widgetInfo, dashboard.assets.ConfigKeys.widgetJump, 
dashboard.assets.ConfigKeys.widgetMove, dashboard.assets.ConfigKeys.widgetRefresh, dashboard.assets.ConfigKeys.toolbarRefresh], viewModel:{data:{autoUpdate:true, unsavedChanges:false, foo:'bar'}, stores:{}}, items:[], moduleActionsMap:{}, initComponent:function() {
  var me = this;
  var vm = me.getViewModel();
  try {
    me.initModuleActionsMap();
    if (this.moduleId === 'dashboard') {
      this.items = [{xtype:'bpcCenterMessageCmp', message:'Dashboard', messageIconCls:'x-fal fa-desktop-alt'}];
      this.callParent();
      return;
    }
    this.getViewModel().set(dashboard.assets.ModuleRights.editDashboard, BpcCommon.Api.hasUserRight(dashboard.assets.ModuleRights.editDashboard));
    this.settings = [];
    Ext.Array.each(this.settingsForVmAndConfigPanel, this.setSettingToVMandSettingPanel.bind(this));
    this.numberOfColumns = BpcCommon.Api.getSetting(this.moduleId, dashboard.assets.ConfigKeys.columns) || 3;
    this.items = this.createDashboard();
    var moduleHeaderContent = BpcCommon.Api.getSetting(me.moduleId, dashboard.assets.ConfigKeys.moduleHeaderContent);
    if (!Ext.isArray(moduleHeaderContent)) {
      moduleHeaderContent = ['add', 'refresh', 'save', 'saveWarning'];
    }
    var appToolbarLeftContent = BpcCommon.Api.getSetting(me.moduleId, dashboard.assets.ConfigKeys.appToolbarLeftContent);
    if (!Ext.isArray(appToolbarLeftContent)) {
      appToolbarLeftContent = [];
    }
    var appToolbarRightContent = BpcCommon.Api.getSetting(me.moduleId, dashboard.assets.ConfigKeys.appToolbarRightContent);
    if (!Ext.isArray(appToolbarRightContent)) {
      appToolbarRightContent = [];
    }
    this.callParent();
    me.applicationToolbarLeft = {xtype:'toolbar', moduleId:me.moduleId, moduleInstance:me, viewModel:{parent:vm}, defaults:{ui:'apptoolbardefault'}, overflowHandler:'scroller', items:me.getModuleActions(appToolbarLeftContent).concat([{xtype:'bpcDashboardLeftToolbarHook', context:{moduleId:'dashboard', instanceId:me.moduleId}}])};
    this.applicationToolbarRight = {xtype:'toolbar', moduleId:me.moduleId, moduleInstance:me, viewModel:{parent:vm}, layout:{pack:'end'}, defaults:{ui:'apptoolbardefault'}, overflowHandler:'scroller', items:[{xtype:'bpcDashboardRightToolbarHook', context:{moduleId:'dashboard', instanceId:this.moduleId}}].concat(me.getModuleActions(appToolbarRightContent))};
    me.bpcModuleHeader = {xtype:'toolbar', moduleId:me.moduleId, moduleInstance:me, viewModel:{parent:vm}, layout:{pack:'end'}, defaults:{ui:'apptoolbardefault'}, overflowHandler:'scroller', items:me.getModuleActions(moduleHeaderContent)};
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
}, recreateDashboard:function() {
  if (this.isVisible(true)) {
    BpcCommon.Api.showModule(this.moduleId, true);
    this.destroy();
  } else {
    if (!this.recreationScheduled) {
      this.recreationScheduled = true;
      this.on('show', this.recreateDashboard, this);
    }
  }
}, createDashboard:function() {
  var dbColumns = [];
  for (var columnIndex = 0; columnIndex < this.numberOfColumns; columnIndex++) {
    var column = {xtype:'dbColumn', columnIndex:columnIndex, itemId:'column' + columnIndex, moduleId:this.moduleId};
    dbColumns.push(column);
    if (columnIndex + 1 !== this.numberOfColumns) {
      dbColumns.push({xtype:'dashboardSplitter'});
    }
  }
  var panelConfig = {xtype:'panel', layout:{type:'hbox', align:'stretch'}, defaults:{flex:1}, ui:'transparent', scrollable:true, items:dbColumns};
  return [panelConfig];
}, setSettingToVMandSettingPanel:function(settingName) {
  try {
    var settingModel = BpcCommon.Api.getSetting(this.moduleId, settingName, true);
    this.settings.push(settingModel);
    this.getViewModel().set(settingName, settingModel.get('value'));
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR setSettingToVMandSettingPanel', dump:e, stack:true, level:'error'});
  }
}, initModuleActionsMap:function() {
  this.moduleActionsMap = {resetuserstate:{xtype:'button', itemId:'resetUserState', iconCls:BpcCommon.Icons.USER_REMOVE, handler:this.getController().resetUserState, scope:this.getController(), hidden:true, bind:{hidden:'{!unsavedChanges}'}, tooltip:BpcCommon.lang.Current.DASHBOARD_USER_STATE_RESET}, savewarning:{itemId:'saveWarning', iconCls:BpcCommon.Icons.WARNING + ' warningColor', localized:{text:'DASHBOARD_UNSAVED_CHANGES'}, hidden:true, bind:{hidden:'{!unsavedChanges || !' + dashboard.assets.ModuleRights.editDashboard + 
  '}'}, handler:this.getController().saveState, scope:this.getController()}, save:{xtype:'button', itemId:'save', iconCls:BpcCommon.Icons.SAVE, localized:{tooltip:'CORE_SAVE'}, handler:this.getController().saveState, scope:this.getController(), hidden:true, bind:{hidden:'{!' + dashboard.assets.ModuleRights.editDashboard + '}'}}, refresh:{xtype:'splitbutton', itemId:'btnAutoRefresh', iconCls:dashboard.assets.Icons.autoRefreshIcon + ' bpcPlay', localized:{tooltip:'CORE_REFRESH'}, handler:this.getController().refreshAllWidgets, 
  scope:this.getController(), menu:{width:200, plain:true, items:[{xtype:'menucheckitem', checked:true, hideOnClick:true, clickHideDelay:50, localized:{text:'DASHBOARD_REFRESH_AUTO'}, handler:this.getController().onAutoRefresh, scope:this.getController()}]}, hidden:true, bind:{hidden:'{!' + dashboard.assets.ConfigKeys.toolbarRefresh + '}'}}, add:{xtype:'splitbutton', itemId:'add', iconCls:BpcCommon.Icons.ADD, localized:{tooltip:'DASHBOARD_WIDGET_ADD'}, handler:this.getController().openSelectorWindow, 
  scope:this.getController(), hidden:true, bind:{hidden:'{!' + dashboard.assets.ModuleRights.editDashboard + '}'}, menu:{plain:true, items:[{localized:{text:'DASHBOARD_DASHBOARD_ADD', tooltip:'DASHBOARD_DASHBOARD_ADD'}, iconCls:dashboard.assets.Icons.DASHBOARD, handler:this.getController().createDashboard, scope:this.getController()}, {localized:{text:'DASHBOARD_WIDGET_ADD', tooltip:'DASHBOARD_WIDGET_ADD'}, iconCls:dashboard.assets.Icons.WIDGET, handler:this.getController().openSelectorWindow, scope:this.getController()}]}}};
}, getModuleActions:function(contentArray) {
  var me = this;
  return contentArray.map(function(key) {
    return Ext.clone(me.moduleActionsMap[String(key).toLowerCase()]);
  });
}});
Ext.define('dashboard.view.MainController', {extend:'Ext.app.ViewController', alias:'controller.dashboardMainController', control:{'*':{widgetConfigurationChange:'setDirty'}, '[isBpcWidget]':{'resize':'saveLocalWidgetConfiguration'}, 'dbWidgetWrapper':{'collapse':'saveLocalWidgetConfiguration', 'expand':'saveLocalWidgetConfiguration'}}, ready:false, autoRefreshInterval:30, forceDashboardRefresh:false, init:function() {
  var me = this;
  try {
    var moduleId = me.getView().moduleId || undefined;
    me.configurationSetting = BpcCommon.Api.getSetting(moduleId, 'configuration', true);
    me.autoRefreshInterval = BpcCommon.Api.getSetting(moduleId, 'refreshInterval');
    me.forceDashboardRefresh = BpcCommon.Api.getSetting(moduleId, 'function_forceDashboardRefresh');
    if (!me.configurationSetting) {
      return;
    }
    var configuration = me.configurationSetting.get('value');
    if (Ext.isArray(configuration) && configuration.length > 0) {
      configuration.forEach(function(config) {
        return me.addWidget(config, true);
      });
      me.configurationSetting.set('value', configuration);
    }
    me.autoRefreshTask = Ext.TaskManager.newTask({run:me.autoRefreshTask.bind(me), interval:1000 * me.autoRefreshInterval});
    me.autoRefreshTask.start();
    me.getView().on('afterrender', function() {
      Ext.defer(function() {
        me.ready = true;
        me.getView().getEl().dom.setAttribute('data-ready', true);
      }, 500);
    });
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR init', dump:e, stack:true, level:'error'});
  }
}, destroy:function() {
  if (this.autoRefreshTask) {
    this.autoRefreshTask.stop();
  }
  this.callParent();
}, autoRefreshTask:function() {
  try {
    var autoRefresh = !this.getViewModel().get('autoUpdate');
    var refreshWidgets = autoRefresh && !BpcCommon.Api.hasWebsocketConnection() || this.forceDashboardRefresh;
    if (refreshWidgets) {
      this.refreshAllWidgets();
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR autoRefreshTask', dump:e, stack:true, level:'error'});
  }
}, widgetSelectorWindow:null, openSelectorWindow:function(btn) {
  var columnIndex = null;
  var columnIndexHolder = btn.up('[columnIndex]');
  if (columnIndexHolder) {
    columnIndex = columnIndexHolder.columnIndex;
  }
  Ext.create('BpcCommon.component.window.Window', {localized:{title:'DASHBOARD_WIDGET_ADD'}, layout:'fit', iconCls:dashboard.assets.Icons.WIDGET, height:550, width:850, resizable:true, constrain:true, items:[{xtype:'dashboardWidgetSelection', stayOpen:false, moduleId:this.getView().moduleId, columnIndex:columnIndex}]}).show();
}, resetUserState:function() {
  var me = this;
  Ext.state.Manager.set(me.getStateId());
  BpcCommon.Api.showModule(me.getView().moduleId, true);
}, saveState:function() {
  var me = this;
  try {
    if (!BpcCommon.Api.hasUserRight(dashboard.assets.ModuleRights.editDashboard)) {
      BpcCommon.Api.showNotification('CORE_ERROR_MISSING_RIGHT');
      return;
    }
    me.configurationSetting.set('value', me.getCurrentDashboardConfiguration());
    me.configurationSetting.save({success:function() {
      BpcCommon.Api.showNotification('DASHBOARD_SAVE_SUCCESSFUL');
      Ext.state.Manager.set(me.getStateId());
      me.setDirty(false);
      Ext.fireEvent('dashboardWidgetConfigSaved');
    }, failure:BpcCommon.Api.showNotification.bind(BpcCommon.Api, 'DASHBOARD_SAVE_FAILED')});
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': saveState ERROR', dump:e, stack:true, level:'error'});
  }
}, getCurrentDashboardConfiguration:function() {
  var me = this;
  var columns = me.getView().query('dbColumn');
  var newConfiguration = [];
  Ext.each(columns, function(column) {
    var columnIndex = column.columnIndex;
    column.items.each(function(widgetWrapper) {
      if (widgetWrapper.widgetId) {
        newConfiguration.push({widgetId:widgetWrapper.widgetId, className:widgetWrapper.baseConfig.className, column:columnIndex, height:widgetWrapper.height || null, flex:widgetWrapper.flex || 0, columnFlex:column.flex || 0, collapsed:widgetWrapper.collapsed, collapsible:widgetWrapper.collapsible, widgetConfiguration:widgetWrapper.widget ? widgetWrapper.widget.getWidgetConfiguration() : {}});
      }
    });
  });
  return newConfiguration;
}, addWidget:function(baseConfig, silent, targetIndex) {
  try {
    var me = this;
    var className = baseConfig.className || baseConfig.widgetId;
    var position = baseConfig.column || 0;
    var height = baseConfig.height;
    var configObj = baseConfig.widgetConfiguration || {};
    var localDashboardConfig = Ext.state.Manager.get(me.getStateId());
    if (Ext.isArray(localDashboardConfig)) {
      me.setDirty(true);
    } else {
      localDashboardConfig = [];
    }
    targetIndex = Ext.isNumber(targetIndex) ? targetIndex : -1;
    baseConfig.collapsed = Ext.isBoolean(baseConfig.collapsed) || Ext.isString(baseConfig.collapsed) ? baseConfig.collapsed : false;
    baseConfig.collapsible = Ext.isBoolean(baseConfig.collapsible) ? baseConfig.collapsible : true;
    var moduleId = this.getView().moduleId;
    var targetColumn = this.getView().down('#column' + position);
    baseConfig.persistenceId = baseConfig.persistenceId || (new Date()).getTime();
    var widgetId = baseConfig.widgetId || baseConfig.persistenceId;
    baseConfig.widgetId = widgetId;
    if (targetColumn) {
      var widgetConfiguration = configObj;
      var widgetState = localDashboardConfig.find(function(widgetConfig) {
        return widgetConfig.widgetId === widgetId;
      });
      if (widgetState && Ext.isObject(widgetState)) {
        widgetConfiguration = Ext.applyIf(widgetState.widgetConfiguration, widgetConfiguration);
        baseConfig = Ext.applyIf(widgetState, baseConfig);
      }
      var widget = BpcCommon.Api.getWidgetComponent(widgetId, {className:className, columnIndex:position, widgetConfiguration:widgetConfiguration, listeners:{scope:this, widgetConfigurationChange:this.saveLocalWidgetConfiguration}, persistenceId:baseConfig.persistenceId});
      baseConfig.className = widget.className;
      var widgetWrapper = targetColumn.add(targetIndex, {xtype:'dbWidgetWrapper', widgetId:widgetId, columnIndex:position, moduleId:moduleId, height:height, items:[widget], persistenceId:baseConfig.persistenceId, flex:baseConfig.flex, collapsed:baseConfig.collapsed, collapsible:baseConfig.collapsible, baseConfig:baseConfig});
      if (baseConfig.columnFlex) {
        targetColumn.setFlex(baseConfig.columnFlex);
        targetColumn.ownerCt.updateLayout();
      }
      if (silent !== true) {
        this.setDirty(true);
      }
      return widgetWrapper;
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': addWidget ERROR', dump:e, stack:true, level:'error'});
  }
}, saveLocalWidgetConfiguration:function() {
  var me = this;
  if (!me.ready) {
    return;
  }
  Ext.state.Manager.set(me.getStateId(), me.getCurrentDashboardConfiguration());
  this.setDirty(true);
}, moveWidget:function(header, columnOffset) {
  try {
    var widgetWrapper = header.up('dbWidgetWrapper');
    var dashboard$0 = this.getView();
    var targetColumn = widgetWrapper.columnIndex + columnOffset;
    if (targetColumn >= 0 && targetColumn < dashboard$0.numberOfColumns) {
      var widgetConfig = widgetWrapper.baseConfig;
      widgetConfig.column = targetColumn;
      this.addWidget(widgetConfig);
      widgetWrapper.close();
    }
    this.setDirty(true);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR moveWidget', dump:e, stack:true, level:'error'});
  }
}, moveWidgetLeft:function(header) {
  this.moveWidget(header, -1);
}, moveWidgetRight:function(header) {
  this.moveWidget(header, 1);
}, removeWidgetWrapper:function(source) {
  try {
    var widget = source.up('dbWidgetWrapper');
    this.setDirty(true);
    widget.close();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR closeWidgetWrapper', dump:e, stack:true, level:'error'});
  }
}, moveWidgetUp:function(header) {
  try {
    var widget = header.up('dbWidgetWrapper');
    var column = widget.up('dbColumn');
    column.moveUp(widget);
    this.setDirty(true);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR moveWidgetUp', dump:e, stack:true, level:'error'});
  }
}, moveWidgetDown:function(header) {
  try {
    var widget = header.up('dbWidgetWrapper');
    var column = widget.up('dbColumn');
    column.moveDown(widget);
    this.setDirty(true);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR moveWidgetDown', dump:e, stack:true, level:'error'});
  }
}, refreshAllWidgets:function() {
  try {
    var dbWrapperArray = this.getView().query('dbWidgetWrapper');
    Ext.Array.each(dbWrapperArray, function(dbWrapper) {
      var btnArr = dbWrapper.getHeader().query('#refreshWidgetBtn');
      if (btnArr.length > 0) {
        btnArr[0].fireHandler();
      }
    });
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR refreshAllWidgets', dump:e, stack:true, level:'error'});
  }
}, onAutoRefresh:function(checkitem) {
  try {
    var splitBtn = checkitem.up('splitbutton');
    var cssCls = splitBtn.iconCls;
    var autoUpdate = null;
    if (checkitem.checked !== true) {
      cssCls = cssCls.replace('bpcPlay', 'bpcPause');
      splitBtn.setIconCls(cssCls);
      autoUpdate = false;
    }
    if (checkitem.checked === true) {
      cssCls = cssCls.replace('bpcPause', 'bpcPlay');
      splitBtn.setIconCls(cssCls);
      autoUpdate = true;
    }
    this.getViewModel().set('autoUpdate', autoUpdate);
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR onAutoRefresh', dump:e, stack:true, level:'error'});
  }
}, configWidget:function(header) {
  var widgetWrapper = header.up('dbWidgetWrapper');
  var widget = widgetWrapper.items.getAt(0);
  if (widget.configureWidget) {
    widget.configureWidget();
  } else {
    Ext.log('Widget does not support configWidget, method not implemented.');
  }
}, refreshWidget:function(header) {
  try {
    var widgetWrapper = header.up('dbWidgetWrapper');
    var widget = widgetWrapper.items.getAt(0);
    if (widget.refreshWidget) {
      widget.refreshWidget();
    } else {
      Ext.log('Widget does not support refresh, method not implemented.');
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR refreshWidget', dump:e, stack:true, level:'error'});
  }
}, createDashboard:function() {
  BpcCommon.Api.createInstanceWithGui('dashboard');
}, setDirty:function(dirty) {
  var me = this;
  me.setDirty = Ext.Function.createThrottled(function(dirty) {
    if (!Ext.isDefined(dirty)) {
      dirty = true;
    }
    me.getViewModel().set('unsavedChanges', !!dirty);
  }, 100);
  me.setDirty(dirty);
}, widgetJumpToModule:function(btn) {
  try {
    var wrapper = btn.up('dbWidgetWrapper');
    var widgetReference = wrapper.down('[isBpcWidget\x3dtrue]');
    if (Ext.isFunction(widgetReference.widgetJumpToModule)) {
      widgetReference.widgetJumpToModule.bind(widgetReference)();
      return;
    }
    var moduleIdHolder = wrapper.down('[moduleId]');
    if (moduleIdHolder) {
      var params = Ext.isFunction(moduleIdHolder.getJumpParams) ? moduleIdHolder.getJumpParams() : undefined;
      BpcCommon.Api.showModule(moduleIdHolder.moduleId, false, params);
    } else {
      BpcCommon.Api.showNotification(BpcCommon.lang.Current.DASHBOARD_MODULE_NOT_FOUND);
    }
  } catch (e) {
    Ext.log({msg:': ERROR handler', dump:e, stack:true, level:'error'});
  }
}, getStateId:function() {
  var me = this;
  return 'bpcDashboard-' + me.getView().moduleId;
}});
Ext.define('dashboard.view.wrapper.WidgetWrapper', {extend:'Ext.panel.Panel', alias:'widget.dbWidgetWrapper', layout:'fit', title:'Dashboard Widget', ui:'hidden-header-items', collapsible:true, iconCls:'x-fal', flex:1, minHeight:100, viewModel:{data:{title:BpcCommon.lang.Current.DASHBOARD_WIDGET_TITLE, tooltip:BpcCommon.lang.Current.DASHBOARD_WIDGET_TOOLTIP, hasConfiguration:false, allowWidgetMove:false}}, header:{items:[{xtype:'toolbar', items:[{xtype:'button', iconCls:BpcCommon.Icons.INFO, bind:{tooltip:'{tooltip}', 
hidden:'{!' + dashboard.assets.ConfigKeys.widgetInfo + '}'}, itemId:'wrapperInfo', moduleId:undefined}, {xtype:'button', iconCls:BpcCommon.Icons.LINK, tooltip:BpcCommon.lang.Current.DASHBOARD_GOTO_MODULE, itemId:'wrapperInstanceLink', bind:{hidden:'{!' + dashboard.assets.ConfigKeys.widgetJump + '}'}, handler:'widgetJumpToModule'}, {xtype:'button', iconCls:'x-fal fa-arrows', arrowVisible:false, menu:{items:[{iconCls:'x-fal fa-arrow-up', text:BpcCommon.lang.Current.DASHBOARD_WIDGET_MOVE_UP, handler:'moveWidgetUp'}, 
{iconCls:'x-fal fa-arrow-down', text:BpcCommon.lang.Current.DASHBOARD_WIDGET_MOVE_DOWN, handler:'moveWidgetDown'}, {iconCls:'x-fal fa-arrow-left', text:BpcCommon.lang.Current.DASHBOARD_WIDGET_MOVE_LEFT, handler:'moveWidgetLeft'}, {iconCls:'x-fal fa-arrow-right', text:BpcCommon.lang.Current.DASHBOARD_WIDGET_MOVE_RIGHT, handler:'moveWidgetRight'}]}, bind:{hidden:'{!allowWidgetMove}'}, tooltip:BpcCommon.lang.Current.DASHBOARD_WIDGET_MOVE}, {xtype:'button', iconCls:BpcCommon.Icons.REFRESH, handler:'refreshWidget', 
bind:{hidden:'{!' + dashboard.assets.ConfigKeys.widgetRefresh + '}'}, itemId:'refreshWidgetBtn', tooltip:BpcCommon.lang.Current.CORE_REFRESH}, {xtype:'button', iconCls:BpcCommon.Icons.SETTING, bind:{hidden:'{!hasConfiguration}'}, handler:'configWidget', tooltip:BpcCommon.lang.Current.CORE_SETTINGS}, {xtype:'button', iconCls:BpcCommon.Icons.DELETE, handler:'removeWidgetWrapper', bind:{hidden:'{!' + dashboard.assets.ModuleRights.editDashboard + '}'}, tooltip:BpcCommon.lang.Current.DASHBOARD_REMOVE_WIDGET}]}]}, 
additionalWidgetActions:undefined, isInitialised:false, initComponent:function() {
  var me = this;
  try {
    var vm = me.getViewModel();
    vm.set('allowWidgetMove', vm.get(dashboard.assets.ModuleRights.editDashboard) && vm.get(dashboard.assets.ConfigKeys.widgetMove));
    if (!Ext.isNumber(me.flex)) {
      me.flex = 1;
    }
    me.callParent();
    me.updateWrapperData(this, me.items.first());
    me.on('add', me.updateWrapperData, this);
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
}, updateWrapperData:function(wrapper, newCmp) {
  try {
    if (newCmp && newCmp.isBpcWidget) {
      this.widget = newCmp;
      var widgetConfig = Ext.clone(newCmp.getWidgetConfiguration());
      if (this.isInitialised === false) {
        if (Ext.isArray(widgetConfig.additionalActions) && widgetConfig.additionalActions.length !== 0) {
          Ext.defer(function() {
            this.addCustomTools(widgetConfig.additionalActions);
          }.bind(this), 100);
        }
      }
      if (widgetConfig.title || widgetConfig.name) {
        var title = BpcCommon.Api.getTranslation(widgetConfig.title || widgetConfig.name);
        this.setTitle(title);
      }
      if (widgetConfig.tooltip || widgetConfig.description) {
        var iconIconTooltip = BpcCommon.Api.getTranslation(widgetConfig.tooltip || widgetConfig.description);
        if (widgetConfig.moduleId && Ext.isDefined(widgetConfig.moduleId)) {
          var moduleInstanceName = BpcCommon.Api.getSetting(widgetConfig.moduleId, 'module_name');
          if (Ext.isDefined(moduleInstanceName)) {
            iconIconTooltip += '\x3cbr\x3e' + moduleInstanceName;
          }
        }
        this.getViewModel().set('tooltip', iconIconTooltip);
      }
      if (widgetConfig.iconCls) {
        this.setIconCls(widgetConfig.iconCls);
      }
      if (!newCmp.widgetWrapper) {
        newCmp.widgetWrapper = this;
        newCmp.on('widgetConfigurationChange', this.updateWrapperData.bind(this, this, newCmp));
      }
      this.getViewModel().set('hasConfiguration', Ext.isFunction(this.widget.configureWidget));
      this.isInitialised = true;
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR updateWrapperData', dump:e, stack:true, level:'error'});
  }
}, addCustomTools:function(additionalActions) {
  var me = this;
  var header = undefined;
  try {
    header = me.getHeader().items.items[1];
  } catch (e) {
    Ext.log({msg:me.self.getName() + ': ERROR can not find header', dump:e, stack:true, level:'error'});
  }
  var actionScope = me.down('[isBpcWidget\x3dtrue]');
  if (!actionScope || !header) {
    return;
  }
  if (Ext.isArray(header.items)) {
    header.items = header.items.filter(function(item) {
      return item.isAdditionalAction === undefined;
    });
  }
  var defaultAction = {xtype:'button', handler:Ext.emptyFn, isAdditionalAction:true};
  Ext.each(additionalActions, function(action) {
    Ext.applyIf(action, defaultAction);
    action.handler = action.handler.bind(actionScope);
    if (header instanceof Ext.panel.Header || Ext.isFunction(header.insert)) {
      header.insert(0, action);
    } else if (Ext.isArray(header.items)) {
      header.items.unshift(action);
    }
  });
}});
Ext.define('dashboard.view.Placeholder', {extend:'dashboard.view.wrapper.WidgetWrapper', alias:'widget.dbWidgetWrapperPlaceHolder', height:250, layout:{type:'vbox', pack:'center', align:'middle'}, iconCls:dashboard.assets.Icons.DASHBOARD, items:[{xtype:'button', iconCls:BpcCommon.Icons.ADD, handler:'openSelectorWindow', bind:{hidden:'{!' + dashboard.assets.ModuleRights.editDashboard + '}'}}, {xtype:'box', html:'\x3ch3\x3e' + BpcCommon.lang.Current.DASHBOARD_WIDGET_ADD_DESCRIPTION + '\x3c/h3\x3e'}], 
initComponent:function() {
  try {
    this.callParent();
    if (Ext.isDefined(this.columnIndex)) {
      this.down('button').columnIndex = this.columnIndex;
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('dashboard.view.Splitter', {extend:'Ext.resizer.Splitter', alias:'widget.dashboardSplitter', collapsible:false, collapseOnDblClick:false, size:8, initComponent:function() {
  this.flex = 0;
  this.callParent();
}});
Ext.define('dashboard.view.selector.WidgetSelectionController', {extend:'Ext.app.ViewController', alias:'controller.dashboardWidgetSelectionController', addWidget:function() {
  try {
    var grid = this.lookupReference('widgetGrid');
    var position = this.lookupReference('positionField').getValue() - 1;
    var selection = grid.getSelection();
    if (selection.length > 0) {
      var widgetModel = selection[0];
      var targetDashboard = Ext.ComponentQuery.query('dbMain[moduleId\x3d' + this.getView().moduleId + ']')[0];
      var targetColumn = targetDashboard.down('dbColumn[columnIndex\x3d' + position + ']');
      var lastWidget = targetColumn.down('dbWidgetWrapper:last');
      targetDashboard.getController().addWidget({className:widgetModel.get('className'), column:position, flex:lastWidget.flex});
      if (!this.getView().stayOpen) {
        this.getView().up('window').close();
      }
    }
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR addWidget', dump:e, stack:true, level:'error'});
  }
}, close:function() {
  try {
    this.getView().up('window').close();
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR close', dump:e, stack:true, level:'error'});
  }
}, onAddMoreChange:function(field) {
  this.getView().stayOpen = field.getValue();
}});
Ext.define('dashboard.view.selector.WidgetSelection', {extend:'Ext.panel.Panel', alias:'widget.dashboardWidgetSelection', requires:['dashboard.view.selector.WidgetSelectionController'], controller:'dashboardWidgetSelectionController', layout:'card', viewModel:{data:{columnIndex:1, maxValue:3, minValue:1}}, moduleId:undefined, columnIndex:undefined, buttons:[{xtype:'bpcGridFilterField', grid:'^ panel grid'}, '-\x3e', {xtype:'numberfield', width:120, plugins:['bpcDynamicFieldLabel'], localized:{fieldLabel:'CORE_COLUMN'}, 
reference:'positionField', bind:{value:'{columnIndex}', maxValue:'{maxValue}', minValue:'{minValue}'}}, {xtype:'checkbox', localized:{boxLabel:'CORE_ADD_MORE'}, listeners:{change:'onAddMoreChange'}}, {iconCls:BpcCommon.Icons.CANCEL, ui:'secondary', localized:{text:'CORE_CANCEL'}, handler:'close'}, {iconCls:BpcCommon.Icons.ADD, ui:'primary', localized:{text:'CORE_ADD'}, handler:'addWidget'}], items:[{xtype:'box', style:'display: flex;justify-content: center;align-items: center;', localized:{html:{tpl:'\x3ci class\x3d"fa fa-spinner fa-pulse fa-5x fa-fw"\x3e\x3c/i\x3e\x3cbr\x3e\x3cspan\x3e{CORE_INSTANCE_LOADING}\x3c/span\x3e', 
keys:['CORE_INSTANCE_LOADING']}}}, {xtype:'grid', reference:'widgetGrid', cls:'widgetGrid', viewConfig:{markDirty:false}, itemId:'widgetGrid', store:BpcCommon.Api.getWidgetStore(), selModel:{selType:'checkboxmodel', mode:'SINGLE'}, columns:[{text:' ', dataIndex:'iconCls', width:35, renderer:function(value) {
  return '\x3ci class\x3d"fa ' + value + '" aria-hidden\x3d"true"\x3e\x3c/i\x3e';
}}, {localized:{text:'CORE_NAME'}, dataIndex:'name', flex:3, cellWrap:true, renderer:function(value, metaData, record) {
  var name = BpcCommon.Api.getTranslation(record.data.name);
  var description = BpcCommon.Api.getTranslation(record.data.description);
  return '\x3cspan data-qtip\x3d"' + name + '"\x3e' + name + '\x3c/span\x3e\x3cbr/\x3e' + ("\x3cspan style\x3d'opacity: .8' data-qtip\x3d\"" + description + '"\x3e' + description + '\x3c/span\x3e');
}}, {localized:{text:'CORE_MODULE_NAME'}, dataIndex:'module', flex:1, listeners:{afterrender:function(cmp) {
  cmp.sort('ASC');
}}}]}], selectionGrid:undefined, initComponent:function() {
  try {
    this.callParent();
    if (Ext.isDefined(this.columnIndex) && this.columnIndex !== null) {
      this.getViewModel().set('columnIndex', this.columnIndex + 1);
    }
    var numberOfColumns = BpcCommon.Api.getSetting(this.moduleId, 'numberOfColumns');
    this.getViewModel().set('maxValue', numberOfColumns);
    BpcCommon.Api.loadAllModules().then(this.setActiveItem.bind(this, 'widgetGrid'));
  } catch (e) {
    Ext.log({msg:this.self.getName() + ': ERROR initComponent', dump:e, stack:true, level:'error'});
  }
}});
Ext.define('dashboard.view.toolbar.PluginHookLeft', {extend:'BpcCommon.plugin.HookContainer', alias:'widget.bpcDashboardLeftToolbarHook', layout:{type:'hbox', align:'middle'}, inheritableStatics:{NAME:'Dashboard Toolbar links', HOOK_ID:'dashboard_toolbar_left'}});
Ext.define('dashboard.view.toolbar.PluginHookRight', {extend:'BpcCommon.plugin.HookContainer', alias:'widget.bpcDashboardRightToolbarHook', layout:{type:'hbox', align:'middle'}, inheritableStatics:{NAME:'Dashboard Toolbar rechts', HOOK_ID:'dashboard_toolbar_right'}});
